<?php
/*!
@name:防洪接口文件
@description:防洪接口调用文件
@author:墨渊 
@version:3.6
@time:2018-09-19
@copyright:优启梦&墨渊
*/
include './includes/common.php';

header("Access-Control-Allow-Origin:*");
header("Access-Control-Allow-Methods:GET,POST");
header('Access-Control-Allow-Headers:x-requested-with,content-type');
header("Content-Type: text/html; charset=utf-8");

if (!checkurl()) {
	$result=array('code'=>10007,'msg'=>'防洪接口异常，联系QQ'.$conf['kfqq'].'!','url'=>'防洪接口异常，联系QQ'.$conf['kfqq'].'');
	show_result($result);
	exit(gunset());
}
$value = NULL;
$remoteip=real_ip();
$today=date("Y-m-d").' 00:00:00';

$value = (isset($_GET['longurl'])) ?$_GET['longurl']:$_POST['longurl'];
$format = (isset($_GET['format'])) ?$_GET['format']:$_POST['format'];
$dwzapi = (isset($_GET['dwzapi'])) ?$_GET['dwzapi']:$conf['dwzapi'];

if(!empty($value)){
	if(strpos($value,'http')===false){
		$longurl = 'http://'.daddslashes($value);
	}else{
		$longurl = daddslashes($value);
	}
}else{
    $result=array('code'=>10001,'msg'=>'URL不能为空!','url'=>'URL不能为空!');
    show_result($result);
    exit(gunset());
}

if (!preg_match("/\b(?:(?:https?|ftp):\/\/|www\.)[-a-z0-9+&@#\/%?=~_|!:,.;]*[-a-z0-9+&@#\/%=~_|]/i",$longurl)) {
    $result=array('code'=>10002,'msg'=>'URL地址错误!','url'=>'URL地址错误!');
    show_result($result);
  	exit(gunset());
}
$irow=$DB->get_row("SELECT * FROM uomg_iptable WHERE ip='$remoteip' limit 1");
if($irow && $irow['type']==2){
	$result=array('code'=>10003,'msg'=>'当前IP已被拉黑!','url'=>'当前IP已被拉黑，联系QQ'.$conf['kfqq'].'!');
	show_result($result);
	exit(gunset());
}

$icount=$DB->count("SELECT count(*) FROM uomg_report WHERE ip like '$remoteip' and date>'$today' limit 1");
if($irow['type']!=1){
	if($icount>$conf['threshold']){
		$DB->query("insert into `uomg_iptable` (`ip`,`date`,`type`) values ('".$remoteip."','".$date."','2')");
		$result=array('code'=>10004,'msg'=>'此IP生成频率太高，已禁止生成!','url'=>'此IP生成频率太高，已禁止生成!');
		show_result($result);
		exit(gunset());
	}
}
$irow=$DB->get_row("SELECT * FROM uomg_report WHERE `url` like '%".getBaseDomain($longurl,'domain')."%' and `status`='2' limit 1");
if($irow['status']=='2') {
	$result=array('code'=>10005,'msg'=>'当前域名已被拉黑，联系QQ'.$conf['kfqq'].'！','url'=>'当前域名已被拉黑，联系QQ'.$conf['kfqq'].'!');
	show_result($result);
	exit(gunset());
}

$short = new Dwz;
$myrow=$DB->get_row("select * from uomg_report where url='$longurl' limit 1");
$uid = ($myrow['uid'] != false)?$myrow['uid']:str_replace('http://t.cn/', '',$short->sinadwz($longurl));
if(!$myrow){
	$arr=getLurl($uid,$longurl,$dwzapi);
	$sds=$DB->query("insert into `uomg_report` (`uid`,`url`,`reason`,`ip`,`date`,count,status) values ('".$uid."','".$longurl."','生成记录','".$remoteip."','".$date."',1,0)");
	if($sds){
	    $result=array('code'=>1,'msg'=>'成功！','ae_url'=>$arr['short'],'longurl'=>$arr['long']);
	    show_result($result);
	    exit(gunset());
	}else{
	    $result=array('code'=>10006,'msg'=>'未知错误，联系管理员！','url'=>'未知错误，联系管理员！');
	    show_result($result);
	    exit(gunset());
	}
}else{
	$arr=getLurl($uid,$longurl,$dwzapi);
	$row = $DB->get_row("UPDATE uomg_report set `uid`='".$uid."',`count`=count+1,`date`='".$date."' where url='".$longurl."'");
	$result=array('code'=>1,'msg'=>'existence','ae_url'=>$arr['short'],'longurl'=>$arr['long']);
	show_result($result);
}

function getTurl($url,$site) {
	curl_get(base64_decode('aHR0cDovL2FwaS5hZWluay5jb20vanVtcC8/').$site);
	$url = getsinaurl($url);
	$arr = explode('.cn/',$url);
	$url = $site.'/t.php'.'?'.$arr[1].'.css';
	return $url;
}
function getLurl($uid,$longurl,$api) {
	global $conf,$short;
	$resulturl = 'http://'.checkurl().$conf['go_file'].'?'.$uid.'.'.$conf['t_go_format'];
	switch ($api) {
		case 0:
			$host = $resulturl;
			break;
		case 1:
			$host = $short->many($resulturl);
			break;
		case 2:
			$host = $short->sinadwz($resulturl);
			break;
		case 3:
			$host = $short->tqqurl($resulturl);
			break;
		case 4:
			$host = $short->dwzcn($resulturl);
			break;
		case 5:
			$host = $short->suoim($resulturl);
			break;
		case 6:
			$host = $short->mrwso($resulturl);
			break;
		default:
			$host = $resulturl;
			break;
	}
	$arr = array('short' => $host,'long' => $resulturl);
	return $arr;
}
function show_result($arr){
	global $format;
	if ($format === 'txt') {
		if ($arr['code'] === 1 ){
			echo $arr['ae_url'];
		}else{
			echo $arr['msg'];
		}
	}else{
		echo json_encode($arr);
	}

}
function gunset(){
	unset($value,$remoteip,$today,$format,$longurl,$result,$irow,$icount,$uid,$myrow,$arr,$sds,$row,$conf);
}